// AOTSystem.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "AOTSystem.h"
#include "registry.h"
#include "../AOTLib/resource.h"
#include "resource.h"
#include "AOTTools.h"
#include "RenameDlg.h"
#include "MainHelperQ.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int AOT_TAB(int i)
{
    CString msg;
    msg.Format(AOT_TAB_MSG, i);
    return ::RegisterWindowMessage(msg);
}

// global data within shared data segment to allow sharing across instances
// struct ///////////////////////////////////////////////////////////////////////////
//
struct WNDDATA
{
    HWND m_hWnd;
    NOTIFYICONDATA m_niData;
    BOOL m_bHooked;
    BOOL m_bMinimized;
    BOOL m_bCaps;
};

#pragma data_seg(".SHARDATA")

HWND g_hwndMain = NULL;
HHOOK g_hookShell = NULL;
HHOOK g_hookMenu = NULL;
HINSTANCE g_hInstance = NULL;
WNDDATA g_listWnd[255];
UINT g_iLastIndex = 0;
UINT g_count = 0;

#pragma data_seg()
#pragma comment(linker, "/section:.SHARDATA,rws")

// extern "C" prevents name mangling so that procedures can be referenced
// from outside the DLL

extern "C"
{
    static LRESULT CALLBACK ShellProc(int nCode, WPARAM wParam, LPARAM lParam);
    static LRESULT CALLBACK MenuProc(int nCode, WPARAM wParam, LPARAM lParam);
}


CAOTSystem::CAOTSystem()
{
}


CAOTSystem theApp;

// initialisation de CtestDllApp

BOOL CAOTSystem::InitInstance()
{
    CWinApp::InitInstance();

    helperMod = m_hInstance;

    RefreshMonitors();

    return TRUE;
}

BOOL CAOTSystem::ExitInstance()
{
    CWinApp::ExitInstance();

    DeleteMonitors();

    return TRUE;
}

__declspec(dllexport) BOOL SetHook(HWND hWnd)
{
    if (g_hwndMain != NULL)
        ClearHook(g_hwndMain);           // we already have a main window, so hooks must already be installed
    g_count = 0;

    // shell hook to add to context menu
    g_hookShell = SetWindowsHookEx(WH_CALLWNDPROC, (HOOKPROC)ShellProc, AfxGetInstanceHandle(), 0);

    // menu hook to handle the menu message
    g_hookMenu = SetWindowsHookEx(WH_GETMESSAGE, (HOOKPROC)MenuProc, AfxGetInstanceHandle(), 0);

    if ((g_hookShell != NULL) && (g_hookMenu != NULL))
    {
        g_hwndMain = hWnd;      // the main window will be whichever window called SetHook
        // ie our main dialog window

        return TRUE;            // both hooks were successfully installed
    }

    return FALSE;               // one or both of the hooks was not installed successfully
}

__declspec(dllexport) BOOL ClearHook(HWND hWnd)
{
    if (hWnd != g_hwndMain || hWnd == NULL)
        return FALSE;

    ::SendMessage(HWND_BROADCAST, AOT_TITLE, 0, 0);

    BOOL unhooked = UnhookWindowsHookEx(g_hookShell);
    if (!unhooked)
        return FALSE;           // did not successfully uninstall the shell hook

    unhooked = UnhookWindowsHookEx(g_hookMenu);
    if (!unhooked)
        return FALSE;           // did not successfully uninstall the menu hook

    // Broadcast a message to ensure clearing hook
    ::SendMessage(HWND_BROADCAST, AOT_TITLE, 0, 0);

    g_hwndMain = NULL;          // successfully uninstalled both hooks therefore do not need
    // to liaise with main window any longer
    return unhooked;
}

// ShellProc - adds / removes the "Toujours visible" entry from the system menu

static LRESULT CALLBACK ShellProc(int nCode, WPARAM wParam, LPARAM lParam)
{
    if (nCode < 0)
    {
        return CallNextHookEx(g_hookShell, nCode, wParam, lParam);
    }

    CWPSTRUCT* wps = (CWPSTRUCT*)lParam;
    HWND hWnd = (HWND)(wps->hwnd);

    if (wps->message == WM_MENUSELECT && wps->lParam == NULL && HIWORD(wps->wParam) == 0xFFFF)
    {
        CMenu* menu = CMenu::FromHandle(GetSystemMenu(hWnd, FALSE));
        if (menu != NULL)
        {
            for (UINT j = 0; j < menu->GetMenuItemCount(); j++)
            {
                UINT menuID = menu->GetMenuItemID(j);
                if (menuID == 0xFFFFFFFF)
                {
                    CMenu* tmp = menu->GetSubMenu(j);
                    CString buf;
                    if (tmp->GetMenuString(AOT_TITLE, buf, MF_BYCOMMAND) > 0)
                    {
                        menu->RemoveMenu(j, MF_BYPOSITION);
                        break;
                    }
                }
            }
        }
    }

    switch (wps->message)
    {
        case WM_ACTIVATEAPP:
            {
                for (UINT i = 0; i < g_iLastIndex; i++)
                {
                    if (g_listWnd[i].m_hWnd == (HWND)wps->hwnd)
                    {
                        if (wps->wParam == FALSE)
                        {
                            //Dsactivation
                            if (g_listWnd[i].m_bCaps == TRUE && GetKeyState(VK_CAPITAL))
                            {
                                INPUT input[2];
                                ::ZeroMemory(input, sizeof(input));        
                                input[0].type = input[1].type = INPUT_KEYBOARD;
                                input[0].ki.wVk = input[1].ki.wVk = VK_CAPITAL;        
                                input[1].ki.dwFlags = KEYEVENTF_KEYUP;  // THIS IS IMPORTANT

                                ::SendInput(2, input, sizeof(INPUT));
                            }
                        }
                        else
                        {
                            //Activation
                            if (g_listWnd[i].m_bCaps == TRUE && !GetKeyState(VK_CAPITAL))
                            {
                                INPUT input[2];
                                ::ZeroMemory(input, sizeof(input));        
                                input[0].type = input[1].type = INPUT_KEYBOARD;
                                input[0].ki.wVk = input[1].ki.wVk = VK_CAPITAL;        
                                input[1].ki.dwFlags = KEYEVENTF_KEYUP;  // THIS IS IMPORTANT

                                ::SendInput(2, input, sizeof(INPUT));
                            }
                        }
                        break;
                    }
                }
                break;
            }
        case WM_INITMENUPOPUP:
            {
                HMENU hMenu = (HMENU)wps->wParam;
                if ((IsMenu(hMenu) & (HIWORD(wps->lParam) == TRUE)))
                {
                    CString buf;

                    if (hMenu == GetSystemMenu(hWnd, FALSE) && CMenu::FromHandle(hMenu)->GetMenuString(AOT_TITLE, buf, MF_BYCOMMAND) <= 0)
                    {
                        CMenu tmpMenu;
                        HMENU tmpHMenu;
                        if (tmpMenu.CreatePopupMenu())
                        {
                            tmpHMenu = tmpMenu.Detach();
                            CMenu::FromHandle(hMenu)->AppendMenu(MF_POPUP, (UINT)tmpHMenu, m_Helper.MyLoadStringFromReg(IDS_LEXTENDEDFUNCTIONS));
                            AppendMenu(tmpHMenu, MF_BYPOSITION | MF_STRING | MF_GRAYED, AOT_TITLE, m_Helper.MyLoadStringFromReg(IDS_LEXTENDEDFUNCTIONS));
                            AppendMenu(tmpHMenu, MF_SEPARATOR, NULL, NULL);
                        }

                        int menuVisible = CRegistry::GetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\AOT"), _T("DisplayVisible"), FALSE);
                        if (menuVisible == TRUE)
                        {
                            if (GetWindowLong(hWnd, GWL_EXSTYLE) & WS_EX_TOPMOST)
                            {
                                AppendMenu(tmpHMenu, MF_CHECKED | MF_BYPOSITION | MF_STRING, AOT_AOT, m_Helper.MyLoadStringFromReg(IDS_LAOT));
                            }
                            else
                            {
                                AppendMenu(tmpHMenu, MF_BYPOSITION | MF_STRING, AOT_AOT, m_Helper.MyLoadStringFromReg(IDS_LAOT));
                            }
                        }

                        int tray = CRegistry::GetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\AOT"), _T("DisplayTrayMe"), FALSE);
                        if (tray == TRUE)
                        {
                            AppendMenu(tmpHMenu, MF_BYPOSITION | MF_STRING, AOT_TRAY, m_Helper.MyLoadStringFromReg(IDS_LTRAYME));
                        }

                        // is system menu
                        if (HIWORD(wps->lParam) == TRUE)
                        {
                            UINT i;
                            // check if this window was hooked or not
                            for (i = 0; i < g_iLastIndex; i++)
                            {
                                if (g_listWnd[i].m_hWnd == (HWND)wps->hwnd)
                                {
                                    break; // exit the for loop
                                }
                            }

                            // not hooked yet
                            if (i == g_iLastIndex)
                            {
                                // store the window handle
                                g_listWnd[i].m_hWnd = (HWND)wps->hwnd;
                                g_listWnd[i].m_bMinimized = FALSE;
                                g_listWnd[i].m_bCaps = FALSE;

                                // get title od that window
                                TCHAR szText[255];
                                GetWindowText(g_listWnd[i].m_hWnd, szText, 255);

                                // prepare a NotifyData struct for this winfow
                                ZeroMemory(&(g_listWnd[i].m_niData), sizeof(NOTIFYICONDATA));
                                g_listWnd[i].m_niData.cbSize = sizeof(NOTIFYICONDATA);
                                g_listWnd[i].m_niData.hWnd = (HWND)wps->hwnd;

                                HICON hIcon = GetIconFromHWnd(g_listWnd[i].m_hWnd, TRUE);

                                if (hIcon)
                                {
                                    g_listWnd[i].m_niData.hIcon = CopyIcon(hIcon);
                                }
                                else
                                {
                                    g_listWnd[i].m_niData.hIcon = LoadIcon(NULL, IDI_QUESTION);
                                }
                                g_listWnd[i].m_niData.uID = 5;
                                g_listWnd[i].m_niData.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
                                _tcscpy(g_listWnd[i].m_niData.szTip, szText);
                                g_listWnd[i].m_niData.uCallbackMessage = AOT_TRAY;

                                // increase count
                                g_iLastIndex++;
                            }
                            if (i < g_iLastIndex)
                            {
                                int caps = CRegistry::GetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\AOT"), _T("DisplayCaps"), FALSE);
                                if (caps == TRUE)
                                {
                                    AppendMenu(tmpHMenu, (g_listWnd[i].m_bCaps ? MF_CHECKED : 0) | MF_BYPOSITION | MF_STRING, AOT_CAPS, m_Helper.MyLoadStringFromReg(IDS_LCAPS));
                                }

                                // set the flag on
                                g_listWnd[i].m_bHooked = TRUE;
                            }

                            int renameWnd = CRegistry::GetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\AOT"), _T("DisplayRenameWnd"), FALSE);
                            if (renameWnd == TRUE)
                            {
                                AppendMenu(tmpHMenu, MF_BYPOSITION | MF_STRING, AOT_RENAME_WND, m_Helper.MyLoadStringFromReg(IDS_LRENAMEWND));
                            }

                            CRect windowRect;
                            ::GetWindowRect(hWnd, &windowRect);

                            WINDOWPLACEMENT wPlacement;
                            wPlacement.length = sizeof wPlacement;
                            ::GetWindowPlacement(HWND(hWnd), &wPlacement);

                            int moniteurPosition = CRegistry::GetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\AOT"), _T("DisplayMonitor"), FALSE);

                            if (moniteurPosition == TRUE)
                            {
                                CString translation = m_Helper.MyLoadStringFromReg(IDS_LSENDTOMONITOR);
                                RefreshMonitors();
                                if (CMenu::FromHandle(tmpHMenu)->GetMenuItemCount() != 2 && m_MonitorArray.GetSize() > 1)
                                    AppendMenu(tmpHMenu, MF_SEPARATOR, NULL, NULL);
                                for (int i = 0; i < m_MonitorArray.GetSize(); i++)
                                {
                                    CMonitor* monitor = m_MonitorArray.GetAt(i);
                                    CString tmp, tmp1;
                                    tmp.Format(translation, i + 1);                
                                    CRect winRect;
                                    CWnd::FromHandle(hWnd)->GetWindowRect(&winRect);

                                    if (!monitor->IsOnMonitor(CWnd::FromHandle(hWnd)) || !monitor->IsOnMonitor(winRect.CenterPoint()))
                                    {
                                        AppendMenu(tmpHMenu, MF_BYPOSITION | MF_STRING, monitor->AOT_DISP, tmp);
                                    }
                                }
                            }

                            int tab = CRegistry::GetRegDWORD(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\AOT"), _T("DisplayTab"), FALSE);
                            if (tab == TRUE)
                            {
                                if (CMenu::FromHandle(tmpHMenu)->GetMenuItemCount() != 2)
                                    AppendMenu(tmpHMenu, MF_SEPARATOR, NULL, NULL);

                                UINT tabSize = SendMessage(g_hwndMain, AOT_TAB_SIZE, 0, 0);

                                for (UINT j = 1; j <= tabSize; j++)
                                {
                                    HWND result = (HWND)SendMessage(g_hwndMain, AOT_TAB_NAME, j, 0);
                                    if (result != NULL)
                                    {
                                        CString title;
                                        TCHAR tmp[255];
                                        ::GetWindowText(result, tmp, 255);
                                        title.Format(_T("%s %s"), m_Helper.MyLoadStringFromReg(IDS_LTAB), tmp);
                                        if (g_listWnd[i].m_hWnd != result && tmp != _T(""))
                                            AppendMenu(tmpHMenu, MF_BYPOSITION | MF_STRING, AOT_TAB(j), title);
                                    }
                                }
                                AppendMenu(tmpHMenu, MF_BYPOSITION | MF_STRING, AOT_NEW_TAB, m_Helper.MyLoadStringFromReg(IDS_LNEWTAB));
                            }

                            // If no option, erase menu
                            CMenu* menu = CMenu::FromHandle(GetSystemMenu(hWnd, FALSE));
                            for (UINT j = 0; j < menu->GetMenuItemCount(); j++)
                            {
                                UINT menuID = menu->GetMenuItemID(j);
                                if (menuID == 0xFFFFFFFF)
                                {
                                    CMenu* tmp = menu->GetSubMenu(j);
                                    CString buf;
                                    if (tmp->GetMenuString(AOT_TITLE, buf, MF_BYCOMMAND) > 0 && tmp->GetMenuItemCount() == 2)
                                    {
                                        menu->RemoveMenu(j, MF_BYPOSITION);
                                        break;
                                    }
                                }
                            }
                        }
                    }
                }
                break;
            }
    }
    if (wps->message == AOT_TITLE)
    {
        ::SendMessage(wps->hwnd, AOT_TRAY, 0, WM_LBUTTONDOWN);
    }

    if (wps->message == AOT_TRAY && wps->lParam == WM_LBUTTONDOWN)
    {
        // determine what window
        for (UINT i = 0; i < g_iLastIndex; i++)
        {
            if (g_listWnd[i].m_hWnd == (HWND)wps->hwnd)
            {
                Shell_NotifyIcon(NIM_DELETE, &g_listWnd[i].m_niData);
                ShowWindow(g_listWnd[i].m_hWnd, SW_SHOW);

                g_listWnd[i].m_bMinimized = FALSE;
                break;
            }
        }
    }

    return CallNextHookEx(g_hookShell, nCode, wParam, lParam);
}

static LRESULT CALLBACK MenuProc(int nCode, WPARAM wParam, LPARAM lParam)
{
    static bool last_top = false;
    static HWND last_wnd = NULL;
    static CMonitor* curMonitor = NULL;

    if (nCode < 0)
    {
        return CallNextHookEx(g_hookMenu, nCode, wParam, lParam);
    }

    MSG* msg = (MSG*)lParam;

    if (msg->message == WM_SYSCOMMAND)
    {
        if (LOWORD(msg->wParam) == AOT_TRAY)
        {
            // iterate to determine the arrival command belongs to which window
            for (UINT i = 0; i < g_iLastIndex; i++)
            {
                if (g_listWnd[i].m_hWnd == (HWND)msg->hwnd)
                {
                    // check if it was not minimized yet
                    if (!g_listWnd[i].m_bMinimized)
                    {
                        // Add icon to tray
                        Shell_NotifyIcon(NIM_ADD, &g_listWnd[i].m_niData);

                        // hide window
                        ShowWindow(g_listWnd[i].m_hWnd, SW_HIDE);

                        // set the flag
                        g_listWnd[i].m_bMinimized = TRUE;
                    }

                    break; // exit the for loop
                }
            }
        }
        if (LOWORD(msg->wParam) == AOT_AOT)
        {
            bool this_top = GetWindowLong(msg->hwnd, GWL_EXSTYLE) & WS_EX_TOPMOST ? true : false;
            if (last_wnd != msg->hwnd || last_top != this_top)
            {
                if (this_top)
                {
                    SetWindowPos(HWND(msg->hwnd), HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_FRAMECHANGED);
                }
                else
                {
                    SetWindowPos(HWND(msg->hwnd), HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_FRAMECHANGED);
                }
                last_wnd = msg->hwnd;
                last_top = this_top;
            }
        }
        if (LOWORD(msg->wParam) == AOT_CAPS)
        {
            for (UINT i = 0; i < g_iLastIndex; i++)
            {
                if (g_listWnd[i].m_hWnd == (HWND)msg->hwnd)
                {
                    g_listWnd[i].m_bCaps = !g_listWnd[i].m_bCaps;

                    INPUT input[2];
                    ::ZeroMemory(input, sizeof(input));        
                    input[0].type = input[1].type = INPUT_KEYBOARD;
                    input[0].ki.wVk = input[1].ki.wVk = VK_CAPITAL;        
                    input[1].ki.dwFlags = KEYEVENTF_KEYUP;  // THIS IS IMPORTANT

                    ::SendInput(2, input, sizeof(INPUT));
                    break;
                }
            }
        }
        if (LOWORD(msg->wParam) == AOT_RENAME_WND)
        {
            CRenameDlg dlg;
            TCHAR tmp[255];
            ::GetWindowText(msg->hwnd, tmp, 255);
            dlg.m_Rename.Format(_T("%s"), tmp);
            dlg.DoModal();
            SetWindowText(msg->hwnd, dlg.m_Rename);

            dlg.DestroyWindow();
        }
        for (UINT i = 1; i <= g_count; i++)
            if (LOWORD(msg->wParam) == AOT_TAB(i))
            {
                ::SendMessage(g_hwndMain, AOT_TAB_HWND, (WPARAM)msg->hwnd, i - 1);
            }
        if (LOWORD(msg->wParam) == AOT_NEW_TAB)
        {
            g_count++;
            ::SendMessage(g_hwndMain, AOT_TAB_HWND, (WPARAM)msg->hwnd, -1);
        }
        for (int i = 0; i < m_MonitorArray.GetSize(); i++)
        {
            CMonitor* monitor = m_MonitorArray.GetAt(i);
            if (LOWORD(msg->wParam) == monitor->AOT_DISP)
            {
                bool curMon = (monitor->IsOnMonitor(CWnd::FromHandle(msg->hwnd)) == TRUE);
                if (last_wnd != msg->hwnd || !curMon)
                {
                    WINDOWPLACEMENT wPlacement;
                    UINT oldShowCmd;
                    CRect monitorRect = monitor->GetMonitorRect();

                    wPlacement.length = sizeof wPlacement;
                    ::GetWindowPlacement(HWND(msg->hwnd), &wPlacement);

                    oldShowCmd = wPlacement.showCmd;
                    if (oldShowCmd == SW_SHOWMAXIMIZED || oldShowCmd == SW_SHOWMINIMIZED)
                    {
                        wPlacement.showCmd = SW_RESTORE;
                        ::SetWindowPlacement(HWND(msg->hwnd), &wPlacement);
                    }
                    monitor->CenterWindowToMonitor(CWnd::FromHandle(msg->hwnd));

                    if (oldShowCmd == SW_SHOWMAXIMIZED)
                    {
                        wPlacement.length = sizeof wPlacement;
                        ::GetWindowPlacement(HWND(msg->hwnd), &wPlacement);
                        wPlacement.showCmd = SW_SHOWMAXIMIZED;
                        wPlacement.ptMaxPosition = monitorRect.TopLeft();
                        ::SetWindowPlacement(HWND(msg->hwnd), &wPlacement);
                    }
                    last_wnd = msg->hwnd;
                    curMonitor = monitor;
                }
            }
        }
    }
    return CallNextHookEx(g_hookMenu, nCode, wParam, lParam);
}

