#ifndef _AOTTOOLS_H_
#define _AOTTOOLS_H_

#include "Psapi.h"

HICON GetIconFromHWnd(HWND hWnd, BOOL bSmallIcon);

typedef struct tagADDMONITOR
{
    int currentIndex;
} ADDMONITOR, * LPADDMONITOR;

// CMonitor 

class CMonitor 
{
public:
    //construction destruction
    CMonitor(HMONITOR hMonitor);
    virtual ~CMonitor();

    //properties
    BOOL IsOnMonitor(const CPoint pt) const;
    BOOL IsOnMonitor(const CWnd* pWnd) const;
    BOOL IsOnMonitor(const CRect lprc) const;

    CRect GetMonitorRect() const;
    void CenterRectToMonitor(LPRECT lprc, const BOOL UseWorkAreaRect = TRUE) const;
    void CenterWindowToMonitor(CWnd* const pWnd, const BOOL UseWorkAreaRect = TRUE) const;
    CRect GetWorkAreaRect() const;
    //operators

    UINT AOT_DISP;
private:
    CRect m_rectMonitor;
	CRect m_rectWork;
};

void DeleteMonitors();
void RefreshMonitors();

BOOL CALLBACK AddMonitorsCallBack(HMONITOR hMonitor, // handle to display monitor
    HDC hdcMonitor, // handle to monitor DC
    LPRECT lprcMonitor, // monitor intersection rectangle
    LPARAM dwData       // data
);

#endif

extern CArray<CMonitor*, CMonitor*> m_MonitorArray;