// ImageInfos.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "resource.h"       // main symbols
#include "ImageInfos.h"
#include "MainHelperQ.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CImageInfos::CImageInfos()
{
}

CImageInfos::~CImageInfos()
{
}

CImageInfos::CImageInfos(CString path)
{
	if(path.Find(_T(",")) == -1)
	{
		m_path = path;
		m_position = 0;
		m_xSize = 1;
		m_ySize = 1;
	}
	else
	{
		m_path = path.Left(path.Find(_T(",")));

		CString data = path.Right(path.GetLength() - path.Find(_T(",")) - 1) + _T(",");

		int infos[3];
		int i = 0;
		for(;i<3;i++)
			infos[i]=1;

		int pos =  0;
		i = 0;
		do {
			infos[i] = _tstoi(data.Mid(pos));
			pos = data.Find(_T(","), pos) + 1;
			i++;
		} while(data.Find(_T(","), pos)!=-1);
		m_position = infos[0];
		m_xSize = infos[1];
		m_ySize = infos[2];
	}
}

CString CImageInfos::GetLabel(CWnd *wnd)
{
	CString label;
    switch (m_position)
    {
        case 0:
			label.Format(_T("%s (%s) [%d,%d]"), m_path, m_Helper.MyLoadString(IDS_TILED), m_xSize, m_ySize);
            break;
        case 1:
            label.Format(_T("%s (%s) [%d,%d]"), m_path, m_Helper.MyLoadString(IDS_CENTER), m_xSize, m_ySize);
            break;
        case 2:
            label.Format(_T("%s (%s) [%d,%d]"), m_path, m_Helper.MyLoadString(IDS_STRETCH), m_xSize, m_ySize);
            break;
        case 3:
            label.Format(_T("%s (%s) [%d,%d]"), m_path, m_Helper.MyLoadString(IDS_ADJUST), m_xSize, m_ySize);
            break;
        case 4:
            label.Format(_T("%s (%s) [%d,%d]"), m_path, m_Helper.MyLoadString(IDS_ADJUSTFROMOUTSIDE), m_xSize, m_ySize);
            break;
        case 5:
            label.Format(_T("%s (%s) [%d,%d]"), m_path, m_Helper.MyLoadString(IDS_AUTOSIZE), m_xSize, m_ySize);
            break;
    }
	if(wnd != NULL && wnd->m_hWnd)
	{
		while(CDC::FromHandle(::GetWindowDC(wnd->m_hWnd))->GetTextExtent(label).cx > 580)
			label = _T("...") + label.Mid(4);
	}
	return label;
}

CString CImageInfos::GetPath()
{
	return m_path;
}

int CImageInfos::GetPosition()
{
	return m_position;
}

int CImageInfos::GetXSize()
{
	return m_xSize;
}

int CImageInfos::GetYSize()
{
	return m_ySize;
}

void CImageInfos::SetPosition(int position)
{
	m_position = position;
}

void CImageInfos::SetXSize(int xSize)
{
	m_xSize = xSize;
}

void CImageInfos::SetYSize(int ySize)
{
	m_ySize = ySize;
}
